// HapticWorkStationInstaller.cpp : Diese Datei enthält die Funktion "main". Hier beginnt und endet die Ausführung des Programms.
//

#include "pch.h"
#include <iostream>
#include <fstream>
#include <sstream>

using namespace std;

#include <direct.h>
#define GetCurrentDir _getcwd

std::string GetCurrentWorkingDir(void) {
	char buff[FILENAME_MAX];
	GetCurrentDir(buff, FILENAME_MAX);
	std::string current_working_dir(buff);
	return current_working_dir;
}

void installHostRegistryEntry() {
	string currentDir = GetCurrentWorkingDir();
	string regEntry = "HKCU\\Software\\Google\\Chrome\\NativeMessagingHosts\\de.philippsuniversity.hapticshost";
	string manifestPath = "\\HapticsChromeExtension\\host\\manifest.json";
	stringstream ss;
	ss<<"REG ADD " << regEntry << " /ve /t REG_SZ /d " << currentDir<<manifestPath << " /f";
	cout << ss.str().c_str() << endl;
	system(ss.str().c_str());
}

void writeStarterBatchFile() {
	std::ofstream file("StartHapticChromeApp.bat");
	file << "@echo off" << endl;
	file << "start Chromium/chrome.exe --app=\"";
	file << GetCurrentWorkingDir();
	file<<"/HapticsChromeExtension/webpage/main.html\" --allow-file-access-from-files --load-extension=..\\HapticsChromeExtension\\app" << endl;
	file << "exit" << endl;
	file.close();
}

int main()
{
	std::cout << "installing messaging host...";
	installHostRegistryEntry();
	std::cout << "creating batch file...";
	writeStarterBatchFile();
	std::cout << "Installation succeeded!\n";
	system("PAUSE");
}
