
var fd_command = document.getElementById('fd_command');
var fd_return = document.getElementById('fd_return');


function processCommand(){
	try {
		if(!fd_command.innerHTML || fd_command.innerHTML == "" || fd_command.innerHTML== "[]")
			return;
		if(port){
			//console.log(fd_command.innerHTML)
			var json = JSON.parse(fd_command.innerHTML);
			port.postMessage(json);
			fd_command.innerHTML = "[]";
		}
	}catch(err){
		console.log("something went wrong when trying to process command (contentScript.js): "+fd_command.innerHTML);
	}
}

console.log("content script loaded");

var port = null;

setInterval(function() {if(port==null){
	port = chrome.runtime.connect({name: "forcedimensionextension"});
	console.log("connection from contentscript to extension: "+port);
	port.onMessage.addListener(function(msg) {
		try {
			var returnArray = msg;
			for(let i = 0; i<returnArray.length;++i){
				var m = JSON.stringify(returnArray[i]);
				if(m.cmd == "debug" || m.cmd == "error"){
					console.log(m)
				}
				if(fd_return.innerHTML.length < 3)
				{
					fd_return.innerHTML = "["+m+"]";
				}
				else{
					fd_return.innerHTML =  fd_return.innerHTML.substr(0,fd_return.innerHTML.length-1)+ "," + m + "]";
				}
			}
		}catch(err){
			console.log("something went wrong when trying to process command coming from the backgroundScript");
			console.log(msg);
		}
	});
	
	port.onDisconnect.addListener(function(){ port = null});
}},1000);
setInterval(processCommand,6);


